VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cMyTheme"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type LOGFONT
  lfHeight As Long
  lfWidth As Long
  lfEscapement As Long
  lfOrientation As Long
  lfWeight As Long
  LFItalic As Byte
  LFUnderline As Byte
  LFStrikeOut As Byte
  lfCharSet As Byte
  lfOutPrecision As Byte
  lfClipPrecision As Byte
  lfQuality As Byte
  lfPitchAndFamily As Byte
  lfFaceName As String * 32
End Type

Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Private Declare Function SystemParametersInfoW Lib "user32" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long

Implements cTheme

Private mThemeColorArray(0 To 6) As Long, mScrollerSize As Long

Private Sub Class_Initialize() 'fill up some Values here, for faster lookup later on
  
  mThemeColorArray(thmBackColor) = RGB(128, 201, 255) 'RGB(235, 235, 235)
  mThemeColorArray(thmForeColor) = RGB(0, 0, 255) 'RGB(30, 30, 30)
  mThemeColorArray(thmBorderColor) = RGB(0, 0, 255) 'RGB(103, 103, 98)
  mThemeColorArray(thmHoverColor) = RGB(0, 255, 255) 'RGB(190, 228, 255)
  mThemeColorArray(thmFocusColor) = RGB(0, 255, 255) 'RGB(0, 140, 195)
  mThemeColorArray(thmSelectionColor) = RGB(255, 0, 255) 'RGB(178, 214, 255)
  mThemeColorArray(thmDisabledColor) = RGB(255, 0, 0) 'RGB(166, 166, 166)
  
  Const SM_CXVSCROLL = 2
  mScrollerSize = GetSystemMetrics(SM_CXVSCROLL) - 2 '<- on Win7 the active ScrollerButtons are two pixels smaller
End Sub

Private Function cTheme_GetIconFontName() As String
Const SPI_GETICONTITLELOGFONT As Long = 31
Static LFW As LOGFONT
  SystemParametersInfoW SPI_GETICONTITLELOGFONT, LenB(LFW), ByVal VarPtr(LFW), 0
  cTheme_GetIconFontName = Left$(LFW.lfFaceName, InStr(LFW.lfFaceName, vbNullChar) - 1)
End Function
 
Private Sub cTheme_FillThemeColorArray(DstThemeColorArray() As Long)
Dim i As Long
  For i = 0 To UBound(mThemeColorArray)
    DstThemeColorArray(i) = mThemeColorArray(i)
  Next i
End Sub

Private Function cTheme_GetThemeColor(WhichColor As enmThemeColor) As Long
  cTheme_GetThemeColor = mThemeColorArray(WhichColor)
End Function

Private Function cTheme_GetScrollerSize() As Long
  cTheme_GetScrollerSize = mScrollerSize
End Function
 
Private Sub cTheme_DrawTo(CC As cCairoContext, W As cWidgetBase, _
                          ByVal What As enmThemeDrawingType, ByVal State As enmThemeDrawingState, _
                          ByVal x As Double, ByVal y As Double, ByVal dx As Double, ByVal dy As Double, _
                          Optional ByVal Radius As Double, Optional ByVal Direction As enmThemeDrawingDirection)

Dim i As Long, Offs As Single, Size As Single, Tmp As Single
Dim Lines As Long, Angle As Long, ZoomFac As Double
Dim Pat As cCairoPattern, Color As Long, Alpha As Single
  
  Alpha = W.AlphaInherited
  CC.Matrix.CalculateScale ZoomFac, ZoomFac
  If TypeOf W.Object Is cwFrame Then Stop
  CC.Save
    Select Case What
      Case thmTypeButtonFace
        CC.SetLineWidth 2
        CC.RoundedRect x, y, dx, dy, Radius, True
        Color = W.BackColor 'Color = cTheme_GetThemeColor(thmBackColor)
        Color = cTheme_GetThemeColor(thmBackColor)
        If Color = -1 Then Color = cTheme_GetThemeColor(thmBackColor)
        If CBool(State And thmStateHovered) And W.Enabled Then Color = W.HoverColor: Offs = 0.05

        Select Case Direction
          Case thmDirectionDown:  Set Pat = Cairo.CreateLinearPattern(x, y, x, dy)
          Case thmDirectionRight: Set Pat = Cairo.CreateLinearPattern(x, y, dx, y)
          Case thmDirectionLeft:  Set Pat = Cairo.CreateLinearPattern(dx, y, x, y)
        End Select
        If State And thmStatePressed Then
          Pat.AddColorStop 0, Color, Alpha * 0.7, 0.82 + Offs
          Pat.AddColorStop 1, Color, Alpha * 0.85, 1 + Offs
        Else
          Pat.AddColorStop 0, Color, Alpha, 1 + Offs
          Pat.AddColorStop 0.49, Color, Alpha, 0.96 + Offs
          Pat.AddColorStop 0.49, Color, Alpha, 0.92 + Offs
          Pat.AddColorStop 1, Color, Alpha, 0.9 + Offs
        End If
        CC.Fill True, Pat

        CC.SetSourceColor vbWhite, IIf(State And thmStatePressed, 0.45, 0.35) * Alpha
        CC.Stroke (State And thmStatePressed)
        If State And thmStatePressed Then CC.Fill , Pat
 
        
      Case thmTypeShine
          CC.RoundedRect x, y, dx, dy, Radius, True
          Select Case Direction
            Case thmDirectionDown:  Set Pat = Cairo.CreateLinearPattern(x, y, x, dy)
            Case thmDirectionRight: Set Pat = Cairo.CreateLinearPattern(x, y, dx, y)
            Case thmDirectionLeft:  Set Pat = Cairo.CreateLinearPattern(dx, y, x, y)
          End Select
            If State And thmStatePressed Then
              Pat.AddColorStop 0, W.SelectionColor, 0.16 * Alpha
              Pat.AddColorStop 0.21, vbWhite, 0.24 * Alpha
              Pat.AddColorStop 1, vbWhite, 0.62 * Alpha
            Else
              Pat.AddColorStop 0, vbWhite, 0.45 * Alpha
              Pat.AddColorStop 1, vbWhite, 0.35 * Alpha
            End If
          CC.Fill , Pat

      Case thmTypeArrow
        CC.TranslateDrawings (x + dx * 0.5) - 0.04, (y + dy * 0.5) + 0.22
        Angle = GetAngle(Direction)
        
        CC.RotateDrawingsDeg Angle
          CC.SetLineWidth 0.4
'            CC.MoveTo -Int(dx * 0.28) + 0.15, 0
'            CC.LineTo Int(dx * 0.28) + 0.45, -Int(dy * 0.5) - 0.45
'            CC.LineTo Int(dx * 0.28) + 0.45, Int(dy * 0.5) + 0.45
            CC.MoveTo -(dx * 0.29), 0
            CC.LineTo (dx * 0.29), -(dy * 0.58)
            CC.LineTo (dx * 0.29), (dy * 0.58)
          CC.ClosePath
        CC.RotateDrawingsDeg -Angle
        
        Color = IIf(W.Enabled, W.ForeColor, W.DisabledColor)
        If State And thmStateHovered And W.Enabled Then Color = W.FocusColor
        Set Pat = Cairo.CreateLinearPattern(-dx * 0.1, -dy * 0.15, dx * 0.3, dy * 0.3)
          Pat.AddColorStop 0, Color, Alpha, 0.8
          Pat.AddColorStop 1, vbWhite, Alpha * 0.7
        CC.Fill True, Pat
        CC.SetSourceColor &HF0F0F0, Alpha * 0.8
        CC.Stroke
        
      Case thmTypeScrollBarGripperMarks
        If dx <= 10 Or dy <= 10 Then CC.Restore: Exit Sub

        If Direction = thmDirectionVert Then
          CC.TranslateDrawings (x + dx - 0.1), 0
          CC.RotateDrawingsDeg 90
          Tmp = x: x = y: y = Tmp
          Tmp = dx: dx = dy: dy = Tmp
        End If
        
        Lines = dx \ 15
        If Lines > 3 Then Lines = 3
        x = Int(x + (dx - 3 * Lines) \ 2 + 2)
        
        CC.SetLineWidth 3
        CC.SetLineCap Cairo_LINE_CAP_ROUND
        CC.SetSourceColor IIf(State And thmStateHovered, W.HoverColor, vbWhite), Alpha * 0.8, 0.95
        Offs = Int(dy * 0.51) + 0.1
        Size = Int(dy * 0.16)
        For i = 0 To Lines - 1
          CC.DrawLine x + 3 * i - 0.5, Offs - Size - 0.2, x + 3 * i - 0.5, Offs + Size + 1.2
          CC.Stroke
        Next i
        
        CC.SetLineWidth 1
        CC.SetLineCap Cairo_LINE_CAP_SQUARE
        CC.SetSourceColor W.ForeColor, Alpha * 0.6, 0.96
        For i = 0 To Lines - 1
          If Direction = thmDirectionVert Then
            CC.DrawLine x + 3 * i - 0.5, Offs - Size - 0.5, x + 3 * i - 0.5, Offs + Size + 1
          Else
            CC.DrawLine x + 3 * i - 0.5, Offs - Size - 0.5, x + 3 * i - 0.5, Offs + Size + 1
          End If
          CC.Stroke
        Next i
        CC.SetSourceColor W.ForeColor, Alpha * 0.6, 1.3
        For i = 0 To Lines - 1
          If Direction = thmDirectionVert Then
            CC.DrawLine x + 3 * i - 0.5, Offs - Size - 0.5, x + 3 * i + 0.35, Offs + Size + 1
          Else
            CC.DrawLine x + 3 * i + 0.5, Offs - Size - 0.5, x + 3 * i - 0.35, Offs + Size + 1
          End If
          CC.Stroke
        Next i
      
      Case thmTypeDottedRectangle
        CC.SetLineWidth 1 / ZoomFac
        x = CLng(x * ZoomFac) / ZoomFac '- 0.05 '+ 0.05
        y = CLng(y * ZoomFac) / ZoomFac '+ 0.05
        Offs = 0.50005 / ZoomFac
        Size = 1.50005 / ZoomFac
        Radius = (Int(Radius * ZoomFac)) / ZoomFac '- 0.3
        dx = CLng((dx + 0.1) * ZoomFac) / ZoomFac - 0.1
        dy = CLng((dy + 0.1) * ZoomFac) / ZoomFac
        CC.RoundedRect x, y, dx, dy, Radius, True
          CC.SetDashes 0.85 / ZoomFac, Offs, Size
          CC.SetSourceColor vbBlack, Alpha * 0.7
        CC.Stroke
        
        CC.RoundedRect x, y, dx, dy, Radius, True
          CC.SetSourceColor vbWhite, Alpha * 0.6
          CC.SetDashes 1.75 / ZoomFac, Offs, Size
        CC.Stroke
        
      Case thmTypeOptionBox
        CC.SetLineWidth 1
        CC.SetLineCap Cairo_LINE_CAP_BUTT
        'Color = IIf(W.MouseOver, W.ShadeColor(W.FocusColor, 0.4), W.BorderColor)
        Color = IIf(W.MouseOver, W.ShadeColor(W.FocusColor, 0.4), mThemeColorArray(thmBorderColor))
        
        CC.ARC x + Radius, y + Radius, Radius
          If W.MouseOver Then
            CC.SetSourceColor W.HoverColor, Alpha '* 0.9
            CC.Fill True
          End If
          CC.SetSourceColor Color, Alpha * 0.75
        CC.Stroke
        
        CC.ARC x + Radius, y + Radius, Radius - 2.27
          CC.SetSourceColor Color, Alpha * 0.4
        CC.Stroke
        
        Set Pat = Cairo.CreateLinearPattern(x, y, x + Radius, y + dy)
          Color = IIf(W.MouseOver, W.HoverColor, &HE8E8E8)
          Pat.AddColorStop 0, Color, Alpha * 0.8, 0.5
          Pat.AddColorStop 0.75, Color, Alpha * 0.8, 1.1
      
          CC.ARC x + Radius + 0.25, y + Radius + 0.25, Radius - 2.47
        CC.Fill , Pat

        If State = thmStateChecked Then
          Set Pat = Cairo.CreateLinearPattern(x + 3.5, y + 5, x + 6, y + dy - 4)
            Pat.AddColorStop 0, vbWhite, Alpha * 0.9
            Pat.AddColorStop 0.5, W.FocusColor, Alpha
            Pat.AddColorStop 1, W.FocusColor, Alpha, 0.6
        
            CC.ARC x + Radius + 0.027, y + Radius + 0.027, 3.1
          CC.Fill True, Pat
          CC.SetSourceColor vbBlack, 0.8
          CC.Stroke
        End If
        
      Case thmTypeCheckBox
        CC.SetLineWidth 1
        CC.SetLineCap Cairo_LINE_CAP_BUTT
        'Color = IIf(W.MouseOver, W.ShadeColor(W.FocusColor, 0.4), W.BorderColor)
        Color = IIf(W.MouseOver, W.ShadeColor(W.FocusColor, 0.4), mThemeColorArray(thmBorderColor))
        
        CC.Rectangle x, y, dx, dy, True
          If W.MouseOver Then
            CC.SetSourceColor W.HoverColor, Alpha '* 0.9
            CC.Fill True
          End If
          CC.SetSourceColor Color, Alpha * 0.7
        CC.Stroke
        
        CC.Rectangle x + 2, y + 2, dx - 4, dy - 4, True
          CC.SetSourceColor Color, Alpha * 0.35
        CC.Stroke
        
        Set Pat = Cairo.CreateLinearPattern(x, y, x + Radius, y + dy)
          Color = IIf(W.MouseOver, W.HoverColor, &HE8E8E8)
          Pat.AddColorStop 0, Color, Alpha * 0.8, 0.5
          Pat.AddColorStop 0.75, Color, Alpha * 0.8, 1.1
      
          CC.Rectangle x + 2.9, y + 2.9, dx - 4.9, dy - 4.9, True
        CC.Fill , Pat

        If State = thmStateChecked Then
          CC.SetLineCap Cairo_LINE_CAP_ROUND
          CC.SetLineWidth 2
            CC.SetSourceColor W.FocusColor, 0.85, 0.27
            x = x + 2: dx = dx - 4
            y = y + 2: dy = dy - 4
            CC.MoveTo x + dx - 1.75, y + 1
            CC.LineTo x + dx * 0.395, y + dy - 1.9
            CC.LineTo x + 1.75, y + dy * 0.55
          CC.Stroke True
          CC.SetLineWidth 1
            CC.SetSourceColor W.FocusColor, 0.35
          CC.Stroke
        ElseIf State = thmStateCheckUndefined Then
          Set Pat = Cairo.CreateLinearPattern(x + 2, y + 3, x + 6, y + dy - 4)
            Pat.AddColorStop 0, vbWhite, Alpha * 0.8
            Pat.AddColorStop 0.5, W.FocusColor, Alpha, 0.9 + IIf(W.MouseOver, 0.3, 0)
            Pat.AddColorStop 1, W.FocusColor, Alpha, 0.65 + IIf(W.MouseOver, 0.3, 0)
        
            CC.Rectangle x + 2, y + 2, dx - 4, dy - 4, True
          CC.Fill True, Pat
          CC.SetSourceColor vbBlack, 0.4
          CC.Stroke
        End If
        
      Case thmTypeBorder
          
          If TypeOf W.Object Is cwMenu Or TypeOf W.Object Is cwTextBox Then
            Radius = 3
            CC.RoundedRect x, y, dx, dy, Radius, True
            Color = mThemeColorArray(thmBorderColor) 'Wolf
          Else
            CC.RoundedRect x, y, dx, dy, Radius, True
            Color = W.BorderColor
          End If
          If State = thmStatePressed Then Color = W.SelectionColor
          If W.Focused Then Color = W.FocusColor
          CC.SetSourceColor Color, IIf(W.MouseOver, 0.85, 0.75) * Alpha
        CC.Stroke
        
      Case thmTypeBottomRightEdge
        CC.Rectangle x, y, dx, dy, True
        Set Pat = Cairo.CreateLinearPattern(x, y, x + dx, y + dy)
            Color = W.BackColor
            If Color = -1 Then Color = cTheme_GetThemeColor(thmBackColor)
            Pat.AddColorStop 0, Color, Alpha, 1.2
            Pat.AddColorStop 0.5, Color, Alpha
            Pat.AddColorStop 0.5, Color, Alpha, 0.9
            Pat.AddColorStop 1, Color, Alpha, 0.95
        CC.Fill , Pat
        
'        CC.TranslateDrawings x + dx, y + dy
'        CC.RotateDrawingsDeg -45
'        If dx > 0 And dy > 0 Then
'          Tmp = IIf(dx > dy, dy / dx, dx / dy)
'          CC.ScaleDrawings Tmp, Tmp
'        End If
'        CC.SetLineWidth 0.8
'        For i = 0 To 2
'          Offs = -(4 + 2 * i)
'          Size = 1 + 2 * i
''          CC.SetSourceColor W.BorderColor, Alpha, 1.15
'          CC.SetSourceColor vbRed, Alpha, 1.15
'          CC.DrawLine -Size, Offs, Size, Offs
'          CC.Stroke
'        Next i

      Case thmTypeListSelection
        Color = W.ShadeColor(IIf(W.DisabledColor = -1, cTheme_GetThemeColor(thmDisabledColor), W.DisabledColor), 1.5)
        If W.Focused And W.Enabled Then Color = W.SelectionColor
        
        Set Pat = Cairo.CreateLinearPattern(x, y + 0.9, x, y + dy - 0.9)
            Pat.AddColorStop 0, Color, Alpha * 0.57, 1.25
            Pat.AddColorStop 0.04, Color, Alpha * 0.58, 1.24
            Pat.AddColorStop 0.12, Color, Alpha * 0.43, 1.11
            Pat.AddColorStop 0.55, Color, Alpha * 0.46, 1.02
            Pat.AddColorStop 0.94, Color, Alpha * 0.56, 0.96
            Pat.AddColorStop 1, vbWhite, Alpha * 0.6
        CC.RoundedRect x, y, dx, dy, Radius, True
          CC.Fill True, Pat
          If W.Focused And W.Enabled Then Color = IIf(W.FocusColor = -1, cTheme_GetThemeColor(thmFocusColor), W.FocusColor)
          CC.SetSourceColor Color, Alpha * 0.5, 0.6
        CC.Stroke
                    
      Case thmTypeSeparatorLine
        x = CLng(x * ZoomFac) / ZoomFac '- 0.05 '+ 0.05
        y = CLng(y * ZoomFac) / ZoomFac '+ 0.05
        If dy > dx Then dx = 1 Else dy = 1
        dx = CLng((dx + 0.1) * ZoomFac) / ZoomFac - 0.1
        dy = CLng((dy + 0.1) * ZoomFac) / ZoomFac
 
        CC.SetLineWidth 2.5 / ZoomFac
        CC.SetLineCap Cairo_LINE_CAP_ROUND
        CC.SetSourceColor vbWhite, 0.3 * Alpha
        CC.MoveTo x + 0.5, y + 0.5
        CC.RelLineTo IIf(dy > dx, 0, dx - 3), IIf(dy > dx, dy - 3, 0)
        CC.Stroke
        
        CC.SetLineWidth 1 / ZoomFac
        Set Pat = Cairo.CreateLinearPattern(x, y, x + IIf(dy > dx, 0, dx), y + IIf(dy > dx, dy, 0))
            Pat.AddColorStop 0, W.BorderColor, Alpha * 0.6 ', 1.27
            Pat.AddColorStop 1, W.BorderColor, 0
        CC.Rectangle x, y, dx, dy, True
        CC.Stroke , Pat
 
      Case thmTypeProgressFace
        Const SmudgeStopSizePixels As Long = 4, SmudgeMinWidth As Long = 20
        Dim ProgBarSmudgeWidth As Double, FinalStopSizePct As Double, ProgBarSmudgeAlpha As Double
        If Radius < 0.8 Then Radius = 0.3 Else Radius = Radius - 0.5
        
        CC.RoundedRect x + 1.25, y + 1, dx, dy - 2.25, Radius, True
          CC.SetSourceColor W.SelectionColor, Alpha
        CC.Fill
        
        CC.RoundedRect x + 2, y + 2.5, dx - 0.8, dy - 4.75, Radius - 0.3, True
          CC.SetSourceColor vbBlack, 0.1 * Alpha
        CC.Fill
        
        ProgBarSmudgeWidth = dx * 0.5
        If ProgBarSmudgeWidth < SmudgeMinWidth Then ProgBarSmudgeWidth = SmudgeMinWidth
        
        'Ensure that the final two stops are a fixed pixel size
        FinalStopSizePct = SmudgeStopSizePixels / (ProgBarSmudgeWidth + SmudgeStopSizePixels) + dx * 0.0002
        
        ProgBarSmudgeAlpha = 0.66
        If dx < SmudgeMinWidth Then 'adjust the Smudge opacity so that the start and end smudges don't noticably overlap
            ProgBarSmudgeAlpha = ProgBarSmudgeAlpha * (dx / SmudgeMinWidth)
        End If
        
        Color = vbBlack 'just in case somebody wants to change the Smudge-BaseColor to something different than vbBlack
        With Cairo.CreateLinearPattern(x + dx - ProgBarSmudgeWidth, 0, x + dx + 1, 0)
          .AddColorStop 0, Color, 0 'this stop 'stretches' while the others are fixed
          .AddColorStop 1 - FinalStopSizePct - FinalStopSizePct, Color, 0.22 * Alpha * ProgBarSmudgeAlpha
          .AddColorStop 1 - FinalStopSizePct, Color, 0.33 * Alpha * ProgBarSmudgeAlpha
          .AddColorStop 1, Color, 0.45 * Alpha * ProgBarSmudgeAlpha
          CC.RoundedRect x + dx - ProgBarSmudgeWidth + 1.1, 2, ProgBarSmudgeWidth, dy - 2.75, Radius + 1, True
          CC.Fill , .This
        End With

        With Cairo.CreateLinearPattern(x, 0, x + ProgBarSmudgeWidth, 0)
          .AddColorStop 0, Color, 0.51 * Alpha * ProgBarSmudgeAlpha
          .AddColorStop FinalStopSizePct, Color, 0.33 * Alpha * ProgBarSmudgeAlpha
          .AddColorStop FinalStopSizePct + FinalStopSizePct, Color, 0.22 * Alpha * ProgBarSmudgeAlpha
          .AddColorStop 1, Color, 0 'this stop 'stretches' while the others are fixed
          CC.RoundedRect x, 2, ProgBarSmudgeWidth, dy - 2.75, Radius + 1, True
          CC.Fill , .This
        End With
 
      Case thmTypeToolButtonFace
      Case thmTypeMenuButtonFace
      Case thmTypeToolBarFace
      Case thmTypeStatusBarFace
      Case thmTypeHeaderFace

      Case thmTypeBorderShadow
      Case thmTypeSliderTrack
 
      Case thmTypeToolBarGrippersMarks
      Case thmTypeResizerGrippersMarks

    End Select
  CC.Restore
End Sub

Private Function GetAngle(Direction As enmThemeDrawingDirection) As Long
  Select Case Direction
    Case thmDirectionDown:  GetAngle = 270
    Case thmDirectionUp:    GetAngle = 90
    Case thmDirectionRight: GetAngle = 180
    Case thmDirectionLeft:  GetAngle = 0
    Case thmDirectionNE:    GetAngle = 135
    Case thmDirectionSE:    GetAngle = 225
    Case thmDirectionSW:    GetAngle = 315
    Case thmDirectionNW:    GetAngle = 45
  End Select
End Function


